package org.gcube.data.access.fs;

import static org.junit.Assert.assertTrue;

import java.io.InputStream;
import java.net.URI;
import java.net.URL;

import org.gcube.common.storagehub.client.dsl.FolderContainer;
import org.gcube.common.storagehub.client.dsl.StorageHubClient;
import org.gcube.common.storagehub.client.dsl.VREFolderManager;
import org.gcube.common.storagehub.model.acls.AccessType;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestWithLocalContainer {

	private static StorageHubClient client;

	private static Logger log = LoggerFactory.getLogger(TestWithLocalContainer.class);

	public static URI storagehubUri;

	
	
	@BeforeClass
	public static void initialize() throws Exception{
		Initializer.setUp();
		storagehubUri = new URL(String.format("http://%s:%d/storagehub", "localhost",8081)).toURI();
		client = new StorageHubClient(storagehubUri);
		createUser();
	}

	@Before
	public void reset() throws Exception {
	}

	private static void createUser() throws Exception{
		client.createUserAccount("test.user");
		client.createUserAccount("test.user2");
		VREFolderManager vremanager = client.getVreFolderManager("gcube-devVre-myvre");
		vremanager.createVRE(AccessType.WRITE_OWNER, "test.user");
		vremanager.addUser("test.user2");
	}

	//impersonating test.user
	@Test
	public void uploadFile() throws Exception{

		client.impersonate("test.user");
		FolderContainer vreFolder = (FolderContainer) client.getVREFolders().getContainers().stream().findFirst().get();
		try (InputStream stream = this.getClass().getResourceAsStream("/output.xlsx")) {
			vreFolder.uploadFile(stream, "userTestfile2", "userTestfile");
		}

		assertTrue(vreFolder.list().getItems().size()>0);
		
		
	}

}


